<?php namespace Myriad\Squire;

class SquireHelpers {

  /**
   * Open a handle to the resource.
   *
   * @param resource|string|\SplFileInfo $resource
   *
   * @return resource|string
   */
  public function openResource($resource) {
    // if we already have a file handle, rewind and return
    if (is_resource($resource)) {
      @rewind($resource);

      return $resource;
    }

    // if the resource extends SplFileInfo, open a handle to the real path
    if ($resource instanceof \SplFileInfo) {
      return fopen($resource->getRealPath(), 'r');
    }

    // if the resource is a readable file path, open a handle to it
    if (is_string($resource) && @is_readable($resource)) {
      return fopen($resource, 'r');
    }

    // check for closed streams
    if (@get_resource_type($resource) === 'Unknown') {
      throw new \InvalidArgumentException('Resource stream is not open.');
    }

    // otherwise just return the resource as is
    return $resource;
  }

}